Public Types | Public Member Functions | Data Fields

# AISettingsWindow Struct Reference

Window for settings the parameters of an AI. More...

Inheritance diagram for AISettingsWindow:

## Public Types
typedef std::vector< const ScriptConfigItem * > | VisibleSettingsList
## Public Member Functions
| AISettingsWindow (WindowDesc *desc, CompanyID slot)
| Constructor for the window.
virtual void | SetStringParameters (int widget) const
| Initialize string parameters for a widget.
void | RebuildVisibleSettings ()
| Rebuilds the list of visible settings.
virtual void | UpdateWidgetSize (int widget, Dimension *size, const Dimension &padding, Dimension *fill, Dimension *resize)
| Update size and resize step of a widget in the window.
virtual void | DrawWidget (const Rect &r, int widget) const
| Draw the contents of a nested widget.
virtual void | OnPaint ()
| The window must be repainted.
virtual void | OnClick (Point pt, int widget, int click_count)
| A click with the left mouse button has been made on the window.
virtual void | OnQueryTextFinished (char *str)
| The query window opened from this window has closed.
virtual void | OnDropdownSelect (int widget, int index)
| A dropdown option associated to this window has been selected.
virtual void | OnDropdownClose (Point pt, int widget, int index, bool instant_close)
| A dropdown window associated to this window has been closed.
virtual void | OnResize ()
| Called after the window got resized.
virtual void | OnTick ()
| Called once per (game) tick.
virtual void | OnInvalidateData (int data=0, bool gui_scope=true)
| Some data on this window has become invalid.
## Data Fields
CompanyID | slot
| The currently show company's setting.
ScriptConfig * | ai_config
| The configuration we're modifying.
int | clicked_button
| The button we clicked.
bool | clicked_increase
| Whether we clicked the increase or decrease button.
bool | clicked_dropdown
| Whether the dropdown is open.
bool | closing_dropdown
| True, if the dropdown list is currently closing.
int | timeout
| Timeout for unclicking the button.
int | clicked_row
| The clicked row of settings.
int | line_height
| Height of a row in the matrix widget.
Scrollbar * | vscroll
| Cache of the vertical scrollbar.
VisibleSettingsList | visible_settings
| List of visible AI settings.

## Detailed Description

Window for settings the parameters of an AI.

Definition at line 280 of file ai_gui.cpp.

## Constructor & Destructor Documentation

AISettingsWindow::AISettingsWindow | ( | WindowDesc * | desc,
|  | CompanyID | slot |
| ) |  |  | `[inline]`

Constructor for the window.

Parameters:

  | desc | The description of the window.
  | slot | The company we're changing the settings for.

Definition at line 299 of file ai_gui.cpp.

References ai_config, Window::CreateNestedTree(), Window::FinishInitNested(), Window::GetScrollbar(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_company_pool >::IsValidID(), RebuildVisibleSettings(), Scrollbar::SetCount(), Window::SetWidgetDisabledState(), visible_settings, vscroll, WID_AIS_RESET, and WID_AIS_SCROLLBAR.

## Member Function Documentation

virtual void AISettingsWindow::DrawWidget | ( | const Rect & | r,
|  | int | widget |
| ) |  |  | const`[inline, virtual]`

Draw the contents of a nested widget.

Parameters:

  | r | Rectangle occupied by the widget.
  | widget | Number of the widget to draw.

Note:
  This method may not change any state, it may only use drawing functions.

Reimplemented from Window.

Definition at line 356 of file ai_gui.cpp.

References _current_text_dir, ai_config, clicked_button, clicked_dropdown, clicked_increase, clicked_row, ScriptConfigItem::complete_labels, SmallMap< T, U, S >::Contains(), ScriptConfigItem::description, DrawArrowButtons(), DrawBoolButton(), DrawDropDownButton(), DrawString(), SmallMap< T, U, S >::Find(), ScriptConfigItem::flags, ScriptConfig::GetSetting(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_company_pool >::IsValidID(), Scrollbar::IsVisible(), ScriptConfigItem::labels, line_height, ScriptConfigItem::max_value, ScriptConfigItem::min_value, ScriptConfigItem::name, SCRIPTCONFIG_BOOLEAN, SCRIPTCONFIG_INGAME, SetDParam(), SetDParamStr(), SETTING_BUTTON_HEIGHT, SETTING_BUTTON_WIDTH, StrEmpty(), visible_settings, vscroll, WD_FRAMERECT_LEFT, WD_MATRIX_TOP, and WID_AIS_BACKGROUND.

virtual void AISettingsWindow::OnClick | ( | Point | pt,
|  | int | widget,
|  | int | click_count |
| ) |  |  | `[inline, virtual]`

A click with the left mouse button has been made on the window.

Parameters:

  | pt | the point inside the window that has been clicked.
  | widget | the clicked widget.
  | click_count | Number of fast consecutive clicks at same position

Reimplemented from Window.

Definition at line 428 of file ai_gui.cpp.

References _current_text_dir, ai_config, SmallVector< T, S >::Append(), clicked_button, clicked_dropdown, clicked_increase, clicked_row, closing_dropdown, ScriptConfigItem::complete_labels, CS_NUMERAL, NWidgetBase::current_x, Window::DeleteChildWindows(), SmallMap< T, U, S >::Find(), ScriptConfigItem::flags, Scrollbar::GetPosition(), ScriptConfig::GetSetting(), HideDropDownMenu(), IsInsideMM(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_company_pool >::IsValidID(), ScriptConfigItem::labels, line_height, ScriptConfigItem::max_value, ScriptConfigItem::min_value, ScriptConfigItem::name, OWNER_DEITY, NWidgetBase::pos_x, NWidgetBase::pos_y, ScriptConfig::ResetSettings(), SCRIPTCONFIG_INGAME, Window::SetDirty(), SetDParam(), ScriptConfig::SetSetting(), SETTING_BUTTON_HEIGHT, SETTING_BUTTON_WIDTH, ShowDropDownListAt(), ShowQueryString(), ScriptConfigItem::step_size, TD_RTL, timeout, visible_settings, vscroll, WC_QUERY_STRING, WID_AIS_ACCEPT, WID_AIS_BACKGROUND, and WID_AIS_RESET.

virtual void AISettingsWindow::OnDropdownClose | ( | Point | pt,
|  | int | widget,
|  | int | index,
|  | bool | instant_close |
| ) |  |  | `[inline, virtual]`

A dropdown window associated to this window has been closed.

Parameters:

  | pt | the point inside the window the mouse resides on after closure.
  | widget | the widget (button) that the dropdown is associated with.
  | index | the element in the dropdown that is selected.
  | instant_close | whether the dropdown was configured to close on mouse up.

Reimplemented from Window.

Definition at line 549 of file ai_gui.cpp.

References clicked_dropdown, closing_dropdown, and Window::SetDirty().

virtual void AISettingsWindow::OnDropdownSelect | ( | int | widget,
|  | int | index |
| ) |  |  | `[inline, virtual]`

A dropdown option associated to this window has been selected.

Parameters:

  | widget | the widget (button) that the dropdown is associated with.
  | index | the element in the dropdown that is selected.

Reimplemented from Window.

Definition at line 539 of file ai_gui.cpp.

References ai_config, clicked_dropdown, clicked_row, ScriptConfig::GetConfigList(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_company_pool >::IsValidID(), OWNER_DEITY, SCRIPTCONFIG_INGAME, Window::SetDirty(), and ScriptConfig::SetSetting().

virtual void AISettingsWindow::OnInvalidateData | ( | int | data = `0`,
|  | bool | gui_scope = `true` |
| ) |  |  | `[inline, virtual]`

Some data on this window has become invalid.

Parameters:

  | data | Information about the changed data.
  | gui_scope | Whether the call is done from GUI scope. You may not do everything when not in GUI scope. See InvalidateWindowData() for details.

Reimplemented from Window.

Definition at line 578 of file ai_gui.cpp.

References RebuildVisibleSettings().

virtual void AISettingsWindow::OnPaint | ( |  | ) | `[inline, virtual]`

The window must be repainted.

Note:
  This method should not change any state, it should only use drawing functions.

Reimplemented from Window.

Definition at line 419 of file ai_gui.cpp.

References clicked_dropdown, closing_dropdown, and Window::DrawWidgets().

virtual void AISettingsWindow::OnQueryTextFinished | ( | char * | str | ) | `[inline, virtual]`

The query window opened from this window has closed.

Parameters:

  | str | the new value of the string, NULL if the window was cancelled or an empty string when the default button was pressed, i.e. StrEmpty(str).

Reimplemented from Window.

Definition at line 528 of file ai_gui.cpp.

References ai_config, clicked_row, ScriptConfig::GetConfigList(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_company_pool >::IsValidID(), OWNER_DEITY, SCRIPTCONFIG_INGAME, Window::SetDirty(), ScriptConfig::SetSetting(), and StrEmpty().

virtual void AISettingsWindow::OnResize | ( |  | ) | `[inline, virtual]`

Called after the window got resized.

For nested windows with a viewport, call NWidgetViewport::UpdateViewportCoordinates.

Reimplemented from Window.

Definition at line 560 of file ai_gui.cpp.

References Scrollbar::SetCapacityFromWidget(), vscroll, and WID_AIS_BACKGROUND.

void AISettingsWindow::RebuildVisibleSettings | ( |  | ) | `[inline]`

Rebuilds the list of visible settings.

AI settings with the flag AICONFIG_AI_DEVELOPER set will only be visible if the game setting gui.ai_developer_tools is enabled.

Definition at line 332 of file ai_gui.cpp.

References _settings_client, ai_config, GUISettings::ai_developer_tools, ScriptConfig::GetConfigList(), ClientSettings::gui, and visible_settings.

Referenced by AISettingsWindow(), and OnInvalidateData().

virtual void AISettingsWindow::SetStringParameters | ( | int | widget | ) | const`[inline, virtual]`

Initialize string parameters for a widget.

Calls to this function are made during initialization to measure the size (that is as part of InitNested()), during drawing, and while re-initializing the window. Only for widgets that render text initializing is requested.

Parameters:

  | widget | Widget number.

Reimplemented from Window.

Definition at line 318 of file ai_gui.cpp.

References OWNER_DEITY, SetDParam(), and WID_AIS_CAPTION.

virtual void AISettingsWindow::UpdateWidgetSize | ( | int | widget,
|  | Dimension * | size,
|  | const Dimension & | padding,
|  | Dimension * | fill,
|  | Dimension * | resize |
| ) |  |  | `[inline, virtual]`

Update size and resize step of a widget in the window.

After retrieval of the minimal size and the resize-steps of a widget, this function is called to allow further refinement, typically by computing the real maximal size of the content. Afterwards, size is taken to be the minimal size of the widget and resize is taken to contain the resize steps. For the convenience of the callee, padding contains the amount of padding between the content and the edge of the widget. This should be added to the returned size.

Parameters:

  | widget | Widget number.
  | size | Size of the widget.
  | padding | Recommended amount of space between the widget content and the widget edge.
  | fill | Fill step of the widget.
  | resize | Resize step of the widget.

Reimplemented from Window.

Definition at line 345 of file ai_gui.cpp.

References FONT_HEIGHT_NORMAL, line_height, WD_MATRIX_TOP, and WID_AIS_BACKGROUND.

The documentation for this struct was generated from the following file:

- src/ai/ai_gui.cpp